org.eclipse.cdt.core.dom.ast.gnu.cpp

## Class GPPLanguage

- java.lang.Object
- - org.eclipse.core.runtime.PlatformObject
  - - org.eclipse.cdt.core.model.AbstractLanguage
    - - org.eclipse.cdt.core.dom.parser.AbstractCLikeLanguage
      - - org.eclipse.cdt.core.dom.ast.gnu.cpp.GPPLanguage

All Implemented Interfaces:
  ICLanguageKeywords, ILanguage, org.eclipse.core.runtime.IAdaptable

    public class GPPLanguage
    extends AbstractCLikeLanguage

Concrete ILanguage implementation for the DOM C++ parser.

### Field Summary

Fields
`protected static GPPParserExtensionConfiguration` `CPP_GNU_PARSER_EXTENSION`
`protected static GPPScannerExtensionConfiguration` `CPP_GNU_SCANNER_EXTENSION`
`static int` `GNU_LATEST_VERSION_MAJOR` Deprecated. This was meant for internal use only.
`static int` `GNU_LATEST_VERSION_MINOR` Deprecated. This was meant for internal use only.
`static String` `ID`

### Fields inherited from interface org.eclipse.cdt.core.model.ILanguage

`OPTION_ADD_COMMENTS, OPTION_IS_SOURCE_UNIT, OPTION_NO_IMAGE_LOCATIONS, OPTION_PARSE_INACTIVE_CODE, OPTION_SKIP_FUNCTION_BODIES, OPTION_SKIP_TRIVIAL_EXPRESSIONS_IN_AGGREGATE_INITIALIZERS`

### Constructor Summary

Constructors
Constructor and Description
`GPPLanguage()`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
`protected ISourceCodeParser` `createParser(IScanner scanner, ParserMode parserMode, IParserLogService logService, IIndex index)`
`protected ISourceCodeParser` `createParser(IScanner scanner, ParserMode parserMode, IParserLogService logService, IIndex index, int options, IParserSettings settings)`
`<T> T` `getAdapter(Class<T> adapter)`
`static GPPLanguage` `getDefault()`
`String` `getId()` Return the language id for this language.
`int` `getLinkageID()` Return the id of the linkage this language contributes to.
`protected ICPPParserExtensionConfiguration` `getParserExtensionConfiguration()` Returns the extension configuration used for creating the parser.
`protected ParserLanguage` `getParserLanguage()`
`protected IScannerExtensionConfiguration` `getScannerExtensionConfiguration()` Deprecated. Since 5.4 not called by the framework. Override `getScannerExtensionConfiguration(IScannerInfo)` instead.
`protected IScannerExtensionConfiguration` `getScannerExtensionConfiguration(IScannerInfo info)`

### Methods inherited from class org.eclipse.cdt.core.dom.parser.AbstractCLikeLanguage

`createModelBuilder, createParser, createParser, createScanner, createScanner, getASTTranslationUnit, getASTTranslationUnit, getASTTranslationUnit, getBuiltinTypes, getCompletionNode, getCompletionNode, getKeywords, getPreprocessorKeywords, getSelectedNames`

### Methods inherited from class org.eclipse.cdt.core.model.AbstractLanguage

`getName`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### CPP_GNU_SCANNER_EXTENSION

    protected static final GPPScannerExtensionConfiguration CPP_GNU_SCANNER_EXTENSION

#### CPP_GNU_PARSER_EXTENSION

    protected static final GPPParserExtensionConfiguration CPP_GNU_PARSER_EXTENSION

#### ID

    public static final String ID

See Also:
  Constant Field Values

#### GNU_LATEST_VERSION_MAJOR

    @Deprecated
    public static final int GNU_LATEST_VERSION_MAJOR

Deprecated. This was meant for internal use only.

Since:
  5.6
See Also:
  Constant Field Values

#### GNU_LATEST_VERSION_MINOR

    @Deprecated
    public static final int GNU_LATEST_VERSION_MINOR

Deprecated. This was meant for internal use only.

Since:
  5.6
See Also:
  Constant Field Values

### Constructor Detail

#### GPPLanguage

    public GPPLanguage()

### Method Detail

#### getDefault

    public static GPPLanguage getDefault()

#### getAdapter

    public <T> T getAdapter(Class<T> adapter)

Specified by:
  `getAdapter` in interface `org.eclipse.core.runtime.IAdaptable`
Overrides:
  `getAdapter` in class `AbstractCLikeLanguage`

#### getId

    public String getId()

Description copied from interface: `ILanguage`
Return the language id for this language. This is to differentiate languages from each other.

#### getLinkageID

    public int getLinkageID()

Description copied from interface: `ILanguage`
Return the id of the linkage this language contributes to. This is especially important for languages that write to the index.

See Also:
  `ILinkage`

#### getScannerExtensionConfiguration

    @Deprecated
    protected IScannerExtensionConfiguration getScannerExtensionConfiguration()

Deprecated. Since 5.4 not called by the framework. Override `getScannerExtensionConfiguration(IScannerInfo)` instead.

Overrides:
  `getScannerExtensionConfiguration` in class `AbstractCLikeLanguage`
Restriction:
  This method is not intended to be re-implemented or extended by clients.

#### getScannerExtensionConfiguration

    protected IScannerExtensionConfiguration getScannerExtensionConfiguration(IScannerInfo info)

Overrides:
  `getScannerExtensionConfiguration` in class `AbstractCLikeLanguage`
Returns:
  the scanner extension configuration for this language. May not return `null`.
Since:
  5.4

#### getParserExtensionConfiguration

    protected ICPPParserExtensionConfiguration getParserExtensionConfiguration()

Returns the extension configuration used for creating the parser.

Since:
  5.1

#### createParser

    protected ISourceCodeParser createParser(IScanner scanner,
                                             ParserMode parserMode,
                                             IParserLogService logService,
                                             IIndex index)

Specified by:
  `createParser` in class `AbstractCLikeLanguage`
Returns:
  the actual parser object.

#### createParser

    protected ISourceCodeParser createParser(IScanner scanner,
                                             ParserMode parserMode,
                                             IParserLogService logService,
                                             IIndex index,
                                             int options,
                                             IParserSettings settings)

Overrides:
  `createParser` in class `AbstractCLikeLanguage`
Returns:
  the actual parser object, configured with additional settings.

#### getParserLanguage

    protected ParserLanguage getParserLanguage()

Specified by:
  `getParserLanguage` in class `AbstractCLikeLanguage`
Returns:
  The ParserLanguage value corresponding to the language supported.